#ifndef DRAW_H_
#define DRAW_H_

/*
 * 	These functions require the surface to be LOCKED.
 */

#include <SDL/SDL.h>
#include <cmath>

#define pset(s, x, y, c) *((Uint32*)((Uint8*)(s)->pixels + (y) * (s)->pitch + 4 * (x))) = (c)

#define pget(s, x, y)    *((Uint32*)((Uint8*)(s)->pixels + (y) * (s)->pitch + 4 * (x)))

void hline( SDL_Surface * s, Sint32 x1, Sint32 x2, Sint32 y, Uint32 c );

void circle( SDL_Surface * s, Sint32 x, Sint32 y, Sint32 r, Uint32 c );
// use negative radius to fill

#endif //DRAW_H_
