#include "fungus.h"

void fungus ( SDL_Surface * screen, Uint32 count )
{
  Sint32 jh, jv, jd;
  Uint32 i, x, y, c;
  for( i = 0; i < count; i++ ){

    //x = mtr.randBits(14) % (screen->w - 2) + 1;
    //y = mtr.randBits(14) % (screen->h - 2) + 1;
    x = mwcr.randInt() % (screen->w - 2) + 1;
    y = mwcr.randInt()  % (screen->h - 2) + 1;

    c = pget(screen, x, y);
    if(c != C_BG)
      if(mwcr.randBits(4) == 0){
        pset(screen, x, y, C_BG);
        //continue;
      }

    jh = jv = jd = 0;
    if(pget(screen, x - 1, y - 1) != C_BG) jd++;
    if(pget(screen, x, y - 1) != C_BG) jv++;
    if(pget(screen, x + 1, y - 1) != C_BG) jd++;
    if(pget(screen, x - 1, y) != C_BG) jh++;
    if(pget(screen, x + 1, y) != C_BG) jh++;
    if(pget(screen, x - 1, y + 1) != C_BG) jd++;
    if(pget(screen, x, y + 1) != C_BG) jv++;
    if(pget(screen, x + 1, y + 1) != C_BG) jd++;

    if(c != C_BG){
      
      if(jv > 0){
        if(pget(screen, x, y - 1) != c && pget(screen, x, y - 1) != C_BG)
          pset(screen, x, y - 1, c);
        if(pget(screen, x, y + 1) != c && pget(screen, x, y + 1) != C_BG)
          pset(screen, x, y + 1, c);
      }
      if(jh > 0){
        if(pget(screen, x - 1, y) != c && pget(screen, x - 1, y) != C_BG)
          pset(screen, x - 1, y, c);
        if(pget(screen, x + 1, y) != c && pget(screen, x + 1, y) != C_BG)
          pset(screen, x + 1, y, c);
      }

      if(jh == 1 && jv == 0){
        if(pget(screen, x - 1, y) == C_BG)
          pset(screen, x - 1, y, c);
        else
          pset(screen, x + 1, y, c);
        continue;
      }
      
      if(jh == 0 && jv == 1){
        if(pget(screen, x, y - 1) == C_BG)
          pset(screen, x, y - 1, c);
        else
          pset(screen, x, y + 1, c);
        continue;
      }
    }
    else // c == C_BG
      if(jd == 0){
        if(jh == 1 && jv == 0)
          pset(screen, x, y, pget(screen, x - 1, y) | pget(screen, x + 1, y));
        else if(jh == 0 && jv == 1)
          pset(screen, x, y, pget(screen, x, y - 1) | pget(screen, x, y + 1));
      }
  }
}


void decay ( SDL_Surface * screen, Uint32 count )
{
  for( Uint32 i = 0; i < count; i++ )
  {
    Sint32 x = mwcr.randInt() % (screen->w - 2) + 1;
    Sint32 y = mwcr.randInt() % (screen->h - 2) + 1;
    Uint32 h = mwcr.randBits(2);
    Uint32 max = 50;
    
    switch( h )
    {
    	default:
    	case 0: // up
    		while( y >= 0 && pget( screen, x, y ) != C_BG && max-- > 0 )
    			pset( screen, x, y--, C_BG );
    		break;
    		
    	case 1: // down
    		while( y < screen->h && pget ( screen, x, y ) != C_BG && max-- > 0 )
    			pset( screen, x, y++, C_BG );
    		break;
    		
    	case 2: // left
    		while( x >= 0 && pget( screen, x, y ) != C_BG && max-- > 0 )
    			pset( screen, x--, y, C_BG );
    		break;
    		
    	case 3: // right
    		while( x < screen->w && pget( screen, x, y ) != C_BG && max-- > 0 )
    			pset( screen, x++, y, C_BG );
    		break;
    }
  }
}
